#include "DIKeyboard.h"
DIKeyboard Keyboard;

IDirectInputDevice *DIKeyboard::Keyboard;

DIKeyboard::DIKeyboard()
{
	Keyboard = NULL;
}

DIKeyboard::~DIKeyboard()
{
	ReleaseKeyboard();
}

void DIKeyboard::Init()
{
	DirectInput->CreateDevice(GUID_SysKeyboard, &Keyboard, NULL);

	Keyboard->SetDataFormat(&c_dfDIKeyboard);

   Keyboard->SetCooperativeLevel(hWnd, DISCL_EXCLUSIVE | DISCL_FOREGROUND);
}

void DIKeyboard::SetAcquire()
{
	Keyboard->Acquire();
}

void DIKeyboard::Input()
{
	Keyboard->GetDeviceState(sizeof(Key), &Key);
}

bool DIKeyboard::KeyPressed(int k)
{
	return (Key[k] & 0x80) != 0;
}

void DIKeyboard::ReleaseKeyboard()
{
	if(Keyboard)
	{
		Keyboard->Release();
		Keyboard = NULL;
	}
}