#ifndef DEBUGLOG_H
#define DEBUGLOG_H

#include <stdio.h>

#define DEBUG_LOG "debug.log"

class DebugLog
{
   const char *File;
	FILE *hFile;

	void New();   // Make and initialise a new file

public:
	DebugLog(const char *file);

	void __cdecl printf(const char *format, ...);   // Write a formatted message to the debug file

	DebugLog &operator<<(char ch);
	DebugLog &operator<<(unsigned char uch);
	DebugLog &operator<<(signed char sch);
	DebugLog &operator<<(const char* psz);
	DebugLog &operator<<(const unsigned char* pusz);
	DebugLog &operator<<(const signed char* pssz);
	DebugLog &operator<<(short s);
	DebugLog &operator<<(unsigned short us);
	DebugLog &operator<<(int n);
	DebugLog &operator<<(unsigned int un);
	DebugLog &operator<<(long l);
	DebugLog &operator<<(unsigned long ul);
	DebugLog &operator<<(float f);
	DebugLog &operator<<(double d);
	DebugLog &operator<<(long double ld);
	DebugLog &operator<<(const void* pv);
};

extern DebugLog Log;   // Standard global debug log

#endif   // DEBUGLOG_H